/* dosfsck.h  -  Common data structures and global variables */

/* Written 1993 by Werner Almesberger */


#ifndef _DOSFSCK_H
#define _DOSFSCK_H

#if __GLIBC__ >= 2
#include <sys/types.h>
#endif
#define _LINUX_STAT_H		/* hack to avoid inclusion of <linux/stat.h> */
#include <linux/msdos_fs.h>


typedef struct msdos_dir_entry DIR_ENT;

typedef struct _dos_file {
    DIR_ENT dir_ent;
    int offset;
    struct _dos_file *parent; /* parent directory */
    struct _dos_file *next; /* next entry */
    struct _dos_file *first; /* first entry (directory only) */
} DOS_FILE;

typedef struct {
    unsigned short value;
    DOS_FILE *owner;
    int prev; /* number of previous clusters */
} FAT_ENTRY;

typedef struct {
    unsigned int fat_start,fat_size; /* unit is bytes */
    unsigned int fat_bits;
    unsigned int root_start,root_entries;
    unsigned int data_start;
    int cluster_size,clusters;
    FAT_ENTRY *fat;
} DOS_FS;


extern int interactive,list,verbose,test,write_immed,Atari_format;
extern void *mem_queue;

#define	FAT_EOF(fat16)	(Atari_format ?				\
			 ((fat16) ? 0xffff : 0xfff) :		\
			 ((fat16) == 16 ? 0xfff8 : 0xff8))
#define	FAT_BAD1(fat16)	(Atari_format ?				\
			 ((fat16) ? 0xfff0 : 0xff0) :		\
			 ((fat16) == 16 ? 0xfff7 : 0xff))
#define	FAT_BAD2(fat16)	(Atari_format ?				\
			 ((fat16) ? 0xfffe : 0xffe) :		\
			 ((fat16) == 16 ? 0xfff7 : 0xff))
#define	FAT_BAD(fat16)	FAT_BAD1(fat16)
#define	FAT_ISBAD(fat16,val)					\
    ((val) >= FAT_BAD1(fat16) && (val) <= FAT_BAD2(fat16))	\
    
#endif
